﻿$(function () {
    if (!makeContactRequired) {
        $("[id$=txtPhone]").removeClass("required");
    }
    if (!useCaptcha) {
        $(".captcha-input").hide();
        $("[id$=txtCaptchaCode]").removeClass("required");
    }

    $(".required").blur(function () {
        if ($("#message").html().length > 0) {
            checkFields();
        }
    });

    $("[id$=btnSendForm]").click(function () {
        checkFields();
        if ($("#message").html().length <= 0) {
            $("#message").html("<img src='" + modulePath + "/desktopmodules/bytutorial.modules.contactform/images/ajax-loader.gif'/> " + res_WaitMessage);
            $(this).attr("disabled", true);
            $("input.required, textarea.required").attr("disabled", true);

            //we build the json string
            var jsonData = {
                'Name': $("[id$=txtName]").val(),
                'Email': $("[id$=txtEmail]").val(),
                'Subject': $("[id$=txtSubject]").val(),
                'Contact': $("[id$=txtPhone]").val(),
                'Message': $("[id$=txtMessage]").val(),
                'Mode': 'contact',
                'TabModuleID': cf_TabModuleID,
                'Captcha': $("[id$=txtCaptchaCode]").val()
            }

            //note in order to proper pass a json string, you have to use function JSON.stringfy
            jsonData = JSON.stringify(jsonData);

            $.ajax({
                url: modulePath + "/desktopmodules/bytutorial.modules.contactform/ContactFormHandler.ashx",
                cache: false,
                type: 'POST',
                data: jsonData,
                success: function (response) {
                    if (response == "OK") {
                        $("#contact-form-inside").hide();
                        $("#message").html("");
                        $("input.required, textarea.required").val("");
                        $("#message").html(res_ThankYouMessage);
                    } else if (response == "CAPTCHA") {
                        $(".button-form").attr("disabled", false);
                        $("input.required, textarea.required").attr("disabled", false);
                        $("#message").html("<div class='error-message'>" + res_CaptchaWrong + "</div>");
                        getCaptchaCode();
                    } else {
                        $("#message").html("<div class='error-message'>" + response + "</div>");
                    }
                },
                error: function (xhr, ajaxOptions, thrownError) {
                    $("#message").html("<div class='error-message'>" + xhr.responseText + "</div>");
                    $(".button-form").attr("disabled", false);
                    $("input.required, textarea.required").attr("disabled", false);
                }
            })
        }
    });

    getCaptchaCode();
});

function getCaptchaCode() {
    $("#captcha-code").html(res_LoadingCaptcha);
    //we build the json string
    var jsonData = {
        'Name': 'N/A',
        'Email': 'N/A',
        'Contact': 'N/A',
        'Message': 'N/A',
        'Mode': 'captcha',
        'TabModuleID': 1,
        'Captcha': 'N/A'
    }

    //note in order to proper pass a json string, you have to use function JSON.stringfy
    jsonData = JSON.stringify(jsonData);

    $.ajax({
        url: modulePath + "/desktopmodules/bytutorial.modules.contactform/ContactFormHandler.ashx",
        cache: false,
        type: 'POST',
        data: jsonData,
        success: function (response) {
            $("#captcha-code").html(response);
        },
        error: function (xhr, ajaxOptions, thrownError) {
            $("#captcha-code").html("<div class='error-message'>" + xhr.responseText + "</div>");
        }
    })
}

function checkFields() {
    var messages = [];
    $("#message").html("");
    $(".required").each(function () {
        if ($(this).val().length <= 0) {
            messages.push("* " + $(this).attr("data-name") + " " + res_Required + "<br/>");
            $(this).addClass("red-border");
        } else {
            $(this).removeClass("red-border");
        }
    });

    $(".email").each(function () {
        if ($(this).val().length > 0 && !validateEmail($(this).val())) {
            messages.push(res_InvalidEmailAddress + "<br/>");
            $(this).addClass("red-border");
        } else {
            if ($(this).val().length > 0) {
                $(this).removeClass("red-border");
            }
        }
    });
    if (messages.length > 0) {
        $("#message").html("<div class='error-message'>" + messages.join('') + "</div>");
    }
}

function validateEmail(email) {
    var re = /^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
    return re.test(email);
}